package techreborn.blocks;

import net.minecraft.block.material.Material;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import reborncore.common.blocks.BlockMachineBase;
import reborncore.common.blocks.IAdvancedRotationTexture;
import techreborn.Core;
import techreborn.client.GuiHandler;
import techreborn.client.TechRebornCreativeTab;
import techreborn.tiles.fusionReactor.TileEntityFusionController;
import techreborn.utils.damageSources.FusionDamageSource;

public class BlockFusionControlComputer extends BlockMachineBase implements IAdvancedRotationTexture
{

	private final String prefix = "techreborn:blocks/machine/greg_machines/";

	public BlockFusionControlComputer(Material material)
	{
		super();
		func_149663_c("techreborn.fusioncontrolcomputer");
		func_149647_a(TechRebornCreativeTab.instance);
	}

	@Override
	public boolean onBlockActivated(World world, int x, int y, int z, EntityPlayer player, int side, float hitX,
			float hitY, float hitZ)
	{
		TileEntityFusionController tileEntityFusionController = (TileEntityFusionController) world
				.func_175625_s(new BlockPos(x, y, z));
		tileEntityFusionController.checkCoils();
		if (!player.func_70093_af())
			player.openGui(Core.INSTANCE, GuiHandler.fusionID, world, x, y, z);
		return true;
	}

	@Override
	public void func_176199_a(World worldIn, BlockPos pos, Entity entityIn)
	{
		super.func_176199_a(worldIn, pos, entityIn);
		if (worldIn.func_175625_s(pos) instanceof TileEntityFusionController)
		{
			if (((TileEntityFusionController) worldIn.func_175625_s(pos)).recipe != null
					&& ((TileEntityFusionController) worldIn.func_175625_s(pos)).checkCoils())
			{
				entityIn.func_70097_a(new FusionDamageSource(), 200F);
			}
		}
	}

	@Override
	public TileEntity func_149915_a(World world, int meta)
	{
		return new TileEntityFusionController();
	}

	@Override
	public String getFront(boolean isActive)
	{
		return prefix + "fusion_control_computer_front";
	}

	@Override
	public String getSide(boolean isActive)
	{
		return prefix + "machine_side";
	}

	@Override
	public String getTop(boolean isActive)
	{
		return prefix + "machine_side";
	}

	@Override
	public String getBottom(boolean isActive)
	{
		return prefix + "machine_side";
	}
}
