package techreborn.blocks.machine;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import reborncore.common.blocks.BlockMachineBase;
import reborncore.common.blocks.IAdvancedRotationTexture;
import techreborn.Core;
import techreborn.client.GuiHandler;
import techreborn.client.TechRebornCreativeTab;
import techreborn.tiles.multiblock.TileVacuumFreezer;

public class BlockVacuumFreezer extends BlockMachineBase implements IAdvancedRotationTexture
{

	private final String prefix = "techreborn:blocks/machine/greg_machines/";

	public BlockVacuumFreezer(Material material)
	{
		super();
		func_149663_c("techreborn.vacuumfreezer");
		func_149647_a(TechRebornCreativeTab.instance);
	}

	@Override
	public TileEntity func_149915_a(World world, int meta) {
		return new TileVacuumFreezer();
	}

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, ItemStack heldItem, EnumFacing side, float hitX, float hitY, float hitZ) {
        if (!player.func_70093_af()) {
            player.openGui(Core.INSTANCE, GuiHandler.vacuumFreezerID, world, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
            return true;
        }
        return false;
    }

    @Override
	public String getFront(boolean isActive)
	{
		return prefix + "vacuum_freezer_front";
	}

	@Override
	public String getSide(boolean isActive)
	{
		return prefix + "machine_side";
	}

	@Override
	public String getTop(boolean isActive)
	{
		return prefix + "vacuum_freezer_top";
	}

	@Override
	public String getBottom(boolean isActive)
	{
		return prefix + "machine_bottom";
	}
}
