package techreborn.client.container;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IContainerListener;
import reborncore.client.gui.BaseSlot;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import reborncore.client.gui.SlotOutput;
import reborncore.common.container.RebornContainer;
import techreborn.api.reactor.FusionReactorRecipe;
import techreborn.tiles.fusionReactor.TileEntityFusionController;

public class ContainerFusionReactor extends RebornContainer {

	public int tickTime;
	public int finalTickTime;

	public int neededEnergy;
	public int energy;

	public boolean hasCoils;

	TileEntityFusionController fusionController;

	public ContainerFusionReactor(TileEntityFusionController tileEntityFusionController, EntityPlayer player) {
		super();
		this.fusionController = tileEntityFusionController;

		func_75146_a(new BaseSlot(tileEntityFusionController, 0, 88, 17));
		func_75146_a(new BaseSlot(tileEntityFusionController, 1, 88, 53));
		func_75146_a(new SlotOutput(tileEntityFusionController, 2, 148, 35));

		int i;

		for (i = 0; i < 3; ++i) {
			for (int j = 0; j < 9; ++j) {
				this.func_75146_a(new BaseSlot(player.field_71071_by, j + i * 9 + 9, 8 + j * 18, 84 + i * 18));
			}
		}

		for (i = 0; i < 9; ++i) {
			this.func_75146_a(new BaseSlot(player.field_71071_by, i, 8 + i * 18, 142));
		}

	}

	@Override
	public boolean func_75145_c(EntityPlayer player) {
		return true;
	}

	@Override
	public void func_75142_b() {
		super.func_75142_b();
		FusionReactorRecipe rec = fusionController.recipe;
		for (int i = 0; i < this.field_75149_d.size(); i++) {
			IContainerListener listener = this.field_75149_d.get(i);
			listener.func_71112_a(this, 0, fusionController.hasCoils ? 1 : 0);
			listener.func_71112_a(this, 1, (int) fusionController.getEnergy());
			listener.func_71112_a(this, 2, rec == null ? 0 : (int) rec.getStartEU());
			listener.func_71112_a(this, 3, rec == null ? -1 : fusionController.recipeTickTime);
			listener.func_71112_a(this, 4, rec == null ? 0 : rec.getTickTime());
		}
	}

	@Override
	public void func_75132_a(IContainerListener listener) {
		super.func_75132_a(listener);
		FusionReactorRecipe rec = fusionController.recipe;
		listener.func_71112_a(this, 0, fusionController.hasCoils ? 1 : 0);
		listener.func_71112_a(this, 1, (int) fusionController.getEnergy());
		listener.func_71112_a(this, 2, rec == null ? 0 : (int) rec.getStartEU());
		listener.func_71112_a(this, 3, rec == null ? -1 : fusionController.recipeTickTime);
		listener.func_71112_a(this, 4, rec == null ? 0 : rec.getTickTime());
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void func_75137_b(int id, int value) {
		switch (id) {
			case 0:
				this.hasCoils = value == 1;
				break;
			case 1:
				this.energy = value;
				break;
			case 2:
				this.neededEnergy = value;
				break;
			case 3:
				this.tickTime = value;
				break;
			case 4:
				this.finalTickTime = value;
				break;
		}
	}

	public int getProgressScaled() {
		return Math.max(0, Math.min(24,
				(this.tickTime > 0 ? 1 : 0) + this.tickTime * 24 / (this.finalTickTime < 1 ? 1 : this.finalTickTime)));
	}

}
