package techreborn.client.gui;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.translation.I18n;
import reborncore.client.gui.GuiUtil;
import reborncore.client.multiblock.Multiblock;
import reborncore.client.multiblock.MultiblockSet;
import reborncore.common.misc.Location;
import reborncore.common.multiblock.CoordTriplet;
import techreborn.client.container.ContainerBlastFurnace;
import techreborn.init.ModBlocks;
import techreborn.proxies.ClientProxy;
import techreborn.tiles.multiblock.TileBlastFurnace;

import java.io.IOException;

public class GuiBlastFurnace extends GuiContainer
{

	public static final ResourceLocation texture = new ResourceLocation("techreborn",
			"textures/gui/industrial_blast_furnace.png");

	TileBlastFurnace blastfurnace;

	ContainerBlastFurnace containerBlastFurnace;
	boolean hasMultiBlock;
	public GuiBlastFurnace(EntityPlayer player, TileBlastFurnace tileblastfurnace)
	{
		super(new ContainerBlastFurnace(tileblastfurnace, player));
		this.field_146999_f = 176;
		this.field_147000_g = 167;
		blastfurnace = tileblastfurnace;
		this.containerBlastFurnace = (ContainerBlastFurnace) this.field_147002_h;
	}

	@Override
	public void func_73866_w_()
	{

		hasMultiBlock = containerBlastFurnace.heat != 0;
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;
		GuiButton button = new GuiButton(212, k + 4, l + 6, 20, 20, "");
		field_146292_n.add(button);
		super.func_73866_w_();
		CoordTriplet coordinates = new CoordTriplet(
				blastfurnace.func_174877_v().func_177958_n() - (EnumFacing.func_82600_a(blastfurnace.getFacingInt()).func_82601_c() * 2),
				blastfurnace.func_174877_v().func_177956_o() - 1, blastfurnace.func_174877_v().func_177952_p()
						- (EnumFacing.func_82600_a(blastfurnace.getFacingInt()).func_82599_e() * 2));
		if (coordinates.equals(ClientProxy.multiblockRenderEvent.anchor) && blastfurnace.getHeat() != 0)
		{
			ClientProxy.multiblockRenderEvent.setMultiblock(null);
			button.field_146126_j = "B";
		} else
		{
			button.field_146126_j = "A";
		}
	}

	@Override
	protected void func_146976_a(float p_146976_1_, int p_146976_2_, int p_146976_3_)
	{
		GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
		this.field_146297_k.func_110434_K().func_110577_a(texture);
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;
		this.func_73729_b(k, l, 0, 0, this.field_146999_f, this.field_147000_g);

		if (hasMultiBlock)
		{
			GuiUtil.drawTooltipBox(k + 30, l + 50 + 12 - 0, 114, 10);
			this.field_146289_q.func_78276_b(I18n.func_74838_a("techreborn.message.missingmultiblock"), k + 38,
					l + 52 + 12 - 0, -1);
		}

		this.field_146297_k.func_110434_K().func_110577_a(texture);
		int j = blastfurnace.getProgressScaled(24);
		if (j > 0)
		{
			this.func_73729_b(k + 64, l + 37, 176, 14, j + 1, 16);
		}

		j = (int)(blastfurnace.getEnergy() * 12f / blastfurnace.getMaxPower());
		if (j > 0) {
			this.func_73729_b(k + 9, l + 36 + 12 - j, 176, 12 - j, 14, j + 2);
		}

	}

	protected void func_146979_b(int p_146979_1_, int p_146979_2_)
	{
		super.func_146979_b(p_146979_1_, p_146979_2_);
		String name = I18n.func_74838_a("tile.techreborn.blastfurnace.name");
		this.field_146289_q.func_78276_b(name, this.field_146999_f / 2 - this.field_146289_q.func_78256_a(name) / 2, 6,
				4210752);
		if (containerBlastFurnace.heat != 0)
		{
			this.field_146289_q.func_78276_b("Current Heat: " + containerBlastFurnace.heat, 40, 60, 4210752);
		}
		this.field_146289_q.func_78276_b(I18n.func_74837_a("container.inventory", new Object[0]), 8,
				this.field_147000_g - 96 + 2, 4210752);
	}

	@Override
	public void func_146284_a(GuiButton button) throws IOException
	{
		super.func_146284_a(button);
		if (button.field_146127_k == 212)
		{
			if (ClientProxy.multiblockRenderEvent.currentMultiblock == null)
			{
				{// This code here makes a basic multiblock and then sets to the
					// selected one.
					Multiblock multiblock = new Multiblock();
					multiblock.addComponent(0, 0, 0, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(1, 0, 0, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(0, 0, 1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 0, 0, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(0, 0, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 0, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 0, 1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(1, 0, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(1, 0, 1, ModBlocks.MachineCasing, 0);

					multiblock.addComponent(1, 1, 0, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(0, 1, 1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 1, 0, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(0, 1, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 1, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 1, 1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(1, 1, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(1, 1, 1, ModBlocks.MachineCasing, 0);

					multiblock.addComponent(1, 2, 0, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(0, 2, 1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 2, 0, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(0, 2, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 2, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 2, 1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(1, 2, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(1, 2, 1, ModBlocks.MachineCasing, 0);

					multiblock.addComponent(0, 3, 0, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(1, 3, 0, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(0, 3, 1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 3, 0, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(0, 3, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 3, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(-1, 3, 1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(1, 3, -1, ModBlocks.MachineCasing, 0);
					multiblock.addComponent(1, 3, 1, ModBlocks.MachineCasing, 0);

					MultiblockSet set = new MultiblockSet(multiblock);
					ClientProxy.multiblockRenderEvent.setMultiblock(set);
					ClientProxy.multiblockRenderEvent.partent = new Location(blastfurnace.func_174877_v().func_177958_n(),
							blastfurnace.func_174877_v().func_177956_o(), blastfurnace.func_174877_v().func_177952_p(), blastfurnace.func_145831_w());
					ClientProxy.multiblockRenderEvent.anchor = new CoordTriplet(
							blastfurnace.func_174877_v().func_177958_n()
									- (EnumFacing.func_82600_a(blastfurnace.getFacingInt()).func_82601_c() * 2),
							blastfurnace.func_174877_v().func_177956_o() - 1, blastfurnace.func_174877_v().func_177952_p()
									- (EnumFacing.func_82600_a(blastfurnace.getFacingInt()).func_82599_e() * 2));
				}
				button.field_146126_j = "A";
			} else
			{
				ClientProxy.multiblockRenderEvent.setMultiblock(null);
				button.field_146126_j = "B";
			}
		}
	}
}
