package techreborn.client.gui;

import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.translation.I18n;
import net.minecraftforge.fluids.FluidStack;
import techreborn.client.container.ContainerIndustrialGrinder;
import techreborn.tiles.multiblock.TileIndustrialGrinder;

public class GuiIndustrialGrinder extends GuiContainer {

    public static final ResourceLocation texture = new ResourceLocation("techreborn",
            "textures/gui/industrial_grinder.png");

    TileIndustrialGrinder grinder;
    ContainerIndustrialGrinder containerGrinder;

    public GuiIndustrialGrinder(EntityPlayer player, TileIndustrialGrinder tilegrinder) {
        super(new ContainerIndustrialGrinder(tilegrinder, player));
        this.field_146999_f = 176;
        this.field_147000_g = 167;
        grinder = tilegrinder;
        containerGrinder = (ContainerIndustrialGrinder) this.field_147002_h;
    }

    @Override
    public void func_73866_w_() {
        int k = (this.field_146294_l - this.field_146999_f) / 2;
        int l = (this.field_146295_m - this.field_147000_g) / 2;
        super.func_73866_w_();
    }

    @Override
    protected void func_146976_a(float p_146976_1_, int p_146976_2_, int p_146976_3_) {
        GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
        this.field_146297_k.func_110434_K().func_110577_a(texture);
        int k = (this.field_146294_l - this.field_146999_f) / 2;
        int l = (this.field_146295_m - this.field_147000_g) / 2;
        this.func_73729_b(k, l, 0, 0, this.field_146999_f, this.field_147000_g);

        int progress = grinder.getProgressScaled(24);
        if (progress > 0) {
            this.func_73729_b(k + 50, l + 35, 176, 14, progress + 1, 16);
        }

        int energy = (int) (grinder.getEnergy() * 12f / grinder.getMaxPower());
        if (energy > 0) {
            this.func_73729_b(k + 132, l + 63 + 12 - energy, 176, 12 - energy, 14, energy + 2);
        }

        if(!grinder.tank.isEmpty()) {
            drawFluid(grinder.tank.getFluid(), k + 11, l + 66, 12, 47, grinder.tank.getCapacity());

            field_146297_k.field_71446_o.func_110577_a(texture);
            func_73729_b(k + 14, l + 24, 179, 88, 9, 37);
        }

        if (!grinder.getMutliBlock()) {
            this.field_146289_q.func_78276_b(I18n.func_74838_a("techreborn.message.missingmultiblock"), k + 38, l + 52 + 12, -1);
        }

    }

    public void drawFluid(FluidStack fluid, int x, int y, int width, int height, int maxCapacity) {
        field_146297_k.field_71446_o.func_110577_a(TextureMap.field_110575_b);
        ResourceLocation still = fluid.getFluid().getStill(fluid);
        TextureAtlasSprite sprite = field_146297_k.func_147117_R().func_110572_b(still.toString());

        int drawHeight = (int) ((fluid.amount / (maxCapacity * 1F)) * height);
        int iconHeight = sprite.func_94216_b();
        int offsetHeight = drawHeight;

        int iteration = 0;
        while(offsetHeight != 0) {
            int curHeight = offsetHeight < iconHeight ? offsetHeight : iconHeight;
            func_175175_a(x, y - offsetHeight, sprite, width, curHeight);
            offsetHeight -= curHeight;
            iteration++;
            if(iteration > 50) break;
        }

    }

    protected void func_146979_b(int p_146979_1_, int p_146979_2_) {
        String name = I18n.func_74838_a("tile.techreborn.industrialgrinder.name");
        this.field_146289_q.func_78276_b(name, this.field_146999_f / 2 - this.field_146289_q.func_78256_a(name) / 2, 6,
                4210752);
        this.field_146289_q.func_78276_b(I18n.func_74837_a("container.inventory", new Object[0]), 8,
                this.field_147000_g - 96 + 2, 4210752);
    }

}
