package techreborn.client.gui;

import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.translation.I18n;
import net.minecraftforge.fluids.FluidStack;
import techreborn.client.container.ContainerIndustrialSawmill;
import techreborn.tiles.multiblock.TileIndustrialSawmill;

public class GuiIndustrialSawmill extends GuiContainer
{

	public static final ResourceLocation texture = new ResourceLocation("techreborn",
			"textures/gui/industrial_sawmill.png");

	TileIndustrialSawmill sawmill;

	public GuiIndustrialSawmill(EntityPlayer player, TileIndustrialSawmill tilesawmill)
	{
		super(new ContainerIndustrialSawmill(tilesawmill, player));
		this.field_146999_f = 176;
		this.field_147000_g = 167;
        this.sawmill = tilesawmill;
	}

	@Override
	public void func_73866_w_()
	{
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;
		super.func_73866_w_();
	}

	@Override
	protected void func_146976_a(float p_146976_1_, int p_146976_2_, int p_146976_3_)
	{
		GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
		this.field_146297_k.func_110434_K().func_110577_a(texture);
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;

		this.func_73729_b(k, l, 0, 0, this.field_146999_f, this.field_147000_g);

		int progress = sawmill.getProgressScaled(24);
		this.func_73729_b(k + 56, l + 38, 176, 14, progress - 1, 11);

		int energy = 13 - (int) (sawmill.getEnergy() / sawmill.getMaxPower() * 13F);
		func_73729_b(k + 36, l + 66 + energy, 179, 1 + energy, 7, 13 - energy);

		if(!sawmill.tank.isEmpty()) {
			drawFluid(sawmill.tank.getFluid(), k + 11, l + 66, 12, 47, sawmill.tank.getCapacity());

			field_146297_k.field_71446_o.func_110577_a(texture);
			func_73729_b(k + 14, l + 24, 179, 88, 9, 37);
		}

		if (!sawmill.getMutliBlock()) {
			//GuiUtil.drawTooltipBox(k + 30, l + 50 + 12, 114, 10);
			this.field_146289_q.func_78276_b(I18n.func_74838_a("techreborn.message.missingmultiblock"), k + 38,
					l + 52 + 12, -1);
		}

	}

	public void drawFluid(FluidStack fluid, int x, int y, int width, int height, int maxCapacity) {
		field_146297_k.field_71446_o.func_110577_a(TextureMap.field_110575_b);
		ResourceLocation still = fluid.getFluid().getStill(fluid);
		TextureAtlasSprite sprite = field_146297_k.func_147117_R().func_110572_b(still.toString());

		int drawHeight = (int) ((fluid.amount / (maxCapacity * 1F)) * height);
		int iconHeight = sprite.func_94216_b();
		int offsetHeight = drawHeight;

		int iteration = 0;
		while(offsetHeight != 0) {
			int curHeight = offsetHeight < iconHeight ? offsetHeight : iconHeight;
			func_175175_a(x, y - offsetHeight, sprite, width, curHeight);
			offsetHeight -= curHeight;
			iteration++;
			if(iteration > 50) break;
		}

	}

	protected void func_146979_b(int p_146979_1_, int p_146979_2_) {
		String name = I18n.func_74838_a("tile.techreborn.industrialsawmill.name");
		this.field_146289_q.func_78276_b(name, this.field_146999_f / 2 - this.field_146289_q.func_78256_a(name) / 2, 6, 4210752);
		this.field_146289_q.func_78276_b(I18n.func_74837_a("container.inventory"), 58, this.field_147000_g - 96 + 2, 4210752);
	}

}
