package techreborn.client.gui;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.translation.I18n;
import techreborn.client.container.ContainerRollingMachine;
import techreborn.tiles.TileRollingMachine;

public class GuiRollingMachine extends GuiContainer
{

	public static final ResourceLocation texture = new ResourceLocation("techreborn",
			"textures/gui/rolling_machine.png");
	TileRollingMachine rollingMachine;
	ContainerRollingMachine containerRollingMachine;

	public GuiRollingMachine(EntityPlayer player, TileRollingMachine tileRollingmachine)
	{
		super(new ContainerRollingMachine(tileRollingmachine, player));
		this.field_146999_f = 176;
		this.field_147000_g = 167;
		rollingMachine = tileRollingmachine;
		containerRollingMachine = (ContainerRollingMachine) this.field_147002_h;
	}

	@Override
	protected void func_146976_a(float p_146976_1_, int p_146976_2_, int p_146976_3_)
	{
		GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
		this.field_146297_k.func_110434_K().func_110577_a(texture);
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;
		this.func_73729_b(k, l, 0, 0, this.field_146999_f, this.field_147000_g);

		int j = this.containerRollingMachine.getBurnTimeRemainingScaled(24);
		this.func_73729_b(k + 91, l + 34, 176, 14, j + 1, 19);

		j = (int)(rollingMachine.getEnergy() * 12f / rollingMachine.getMaxPower());
		if (j > 0)
		{
			this.func_73729_b(k + 7, l + 33 + 12 - j, 176, 12 - j, 14, j + 2);
		}
	}

	protected void func_146979_b(int p_146979_1_, int p_146979_2_)
	{
		String name = I18n.func_74838_a("tile.techreborn.rollingmachine.name");
		this.field_146289_q.func_78276_b(name, this.field_146999_f / 2 - this.field_146289_q.func_78256_a(name) / 2, 6,
				4210752);
		this.field_146289_q.func_78276_b(I18n.func_74837_a("container.inventory", new Object[0]), 8,
				this.field_147000_g - 96 + 2, 4210752);
	}

	@Override
	public void func_73866_w_()
	{
		this.field_146292_n.clear();
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;
		this.field_146292_n.add(new GuiButton(0, k + 4, l + 4, 20, 20, "R"));
		super.func_73866_w_();
	}

}
