package techreborn.client.gui;

import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.translation.I18n;
import techreborn.client.container.ContainerVacuumFreezer;
import techreborn.tiles.multiblock.TileVacuumFreezer;

public class GuiVacuumFreezer extends GuiContainer {

    public static final ResourceLocation texture = new ResourceLocation("techreborn", "textures/gui/vacuum_freezer.png");

    TileVacuumFreezer crafter;

    public GuiVacuumFreezer(EntityPlayer player, TileVacuumFreezer freezer) {
        super(new ContainerVacuumFreezer(freezer, player));
        this.field_146999_f = 176;
        this.field_147000_g = 167;
        crafter = freezer;
    }

    @Override
    protected void func_146976_a(float partialTicks, int mouseX, int mouseY) {
        GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
        this.field_146297_k.func_110434_K().func_110577_a(texture);
        int k = (this.field_146294_l - this.field_146999_f) / 2;
        int l = (this.field_146295_m - this.field_147000_g) / 2;
        this.func_73729_b(k, l, 0, 0, this.field_146999_f, this.field_147000_g);

        int j = crafter.getProgressScaled(24);
        if (j > 0) {
            this.func_73729_b(k + 80, l + 37, 176, 14, j + 1, 16);
        }

        j = (int) (crafter.getEnergy() * 12f / crafter.getMaxPower());
        if (j > 0) {
            this.func_73729_b(k + 26, l + 36 + 12 - j, 176, 12 - j, 14, j + 2);
        }

        if (!crafter.getMultiBlock()) {
            this.field_146289_q.func_78276_b(I18n.func_74838_a("techreborn.message.missingmultiblock"), k + 38, l + 52 + 12, -1);
        }

    }

    protected void func_146979_b(int mouseX, int mouseY) {
        String name = I18n.func_74838_a("tile.techreborn.vacuumfreezer.name");
        this.field_146289_q.func_78276_b(name, this.field_146999_f / 2 - this.field_146289_q.func_78256_a(name) / 2, 6, 4210752);
        this.field_146289_q.func_78276_b(I18n.func_74837_a("container.inventory"), 8, this.field_147000_g - 96 + 2, 4210752);
    }


}
