package techreborn.tiles.generator;

import net.minecraft.util.EnumFacing;
import net.minecraft.util.ITickable;
import net.minecraft.util.math.BlockPos;
import reborncore.api.power.EnumPowerTier;
import reborncore.common.tile.TilePowerProducer;
import techreborn.blocks.generator.BlockSolarPanel;
import techreborn.power.EnergyUtils;

import java.util.List;

/**
 * Created by modmuss50 on 25/02/2016.
 */
public class TileSolarPanel extends TilePowerProducer implements ITickable {

	boolean shouldMakePower = false;

	int powerToAdd;

	@Override
	public void func_73660_a() {
		super.func_73660_a();
		if (!field_145850_b.field_72995_K) {
			if (field_145850_b.func_82737_E() % 60 == 0) {
				shouldMakePower = isSunOut();

			}
			if (shouldMakePower) {
				powerToAdd = 10;
				addEnergy(powerToAdd);
			} else {
				powerToAdd = 0;
			}
			field_145850_b.func_175656_a(func_174877_v(), field_145850_b.func_180495_p(this.func_174877_v()).func_177226_a(BlockSolarPanel.ACTIVE, isSunOut()));
		}
	}

	@Override
	public void addInfo(List<String> info, boolean isRealTile) {
		super.addInfo(info, isRealTile);
		if (isRealTile) {
			// FIXME: 25/02/2016
			// info.add(TextFormatting.LIGHT_PURPLE + "Power gen/tick " +
			// TextFormatting.GREEN + PowerSystem.getLocalizedPower(
			// powerToAdd)) ;
		}
	}

	@Override
	public double emitEnergy(EnumFacing enumFacing, double amount) {
		BlockPos pos = func_174877_v().func_177972_a(enumFacing);
		EnergyUtils.PowerNetReceiver receiver = EnergyUtils.getReceiver(
				field_145850_b, enumFacing.func_176734_d(), pos);
		if(receiver != null) {
			addEnergy(amount - receiver.receiveEnergy(amount, false));
		} else addEnergy(amount);
		return 0; //Temporary hack die to my bug RebornCore
	}

	public boolean isSunOut() {
		return field_145850_b.func_175710_j(field_174879_c.func_177984_a()) && !field_145850_b.func_72896_J() && !field_145850_b.func_72911_I()
				&& field_145850_b.func_72935_r();
	}

	@Override
	public double getMaxPower() {
		return 8000;
	}

	@Override
	public EnumPowerTier getTier() {
		return EnumPowerTier.LOW;
	}

}
