package techreborn.tiles.teir1;

import ic2.core.upgrade.IUpgradeItem;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ISidedInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.util.EnumFacing;
import reborncore.api.power.EnumPowerTier;
import reborncore.api.tile.IInventoryProvider;
import reborncore.common.IWrenchable;
import reborncore.common.blocks.BlockMachineBase;
import reborncore.common.recipes.RecipeCrafter;
import reborncore.common.tile.TilePowerAcceptor;
import reborncore.common.util.Inventory;
import techreborn.init.ModBlocks;
import techreborn.utils.upgrade.UpgradeHandler;

public class TileElectricFurnace extends TilePowerAcceptor implements IWrenchable,IInventoryProvider, ISidedInventory {

	public Inventory inventory = new Inventory(6, "TileElectricFurnace", 64, this);
	public int progress;
	public int fuelScale = 100;
	public int cost = 8;
	int input1 = 0;
	int output = 1;
	private static final int[] SLOTS_TOP = new int[]{0};
	private static final int[] SLOTS_BOTTOM = new int[]{1};
	private static final int[] SLOTS_SIDES = new int[]{1};

	public int gaugeProgressScaled(int scale) {
		return (progress * scale) / fuelScale;
	}

	@Override
	public void func_73660_a() {
		super.func_73660_a();
		//charge(3); TODO

		boolean burning = isBurning();
		boolean updateInventory = false;
		if (isBurning() && canSmelt()) {
			updateState();

			progress++;
			if (progress % 10 == 0) {
				useEnergy(cost);
			}
			if (progress >= fuelScale) {
				progress = 0;
				cookItems();
				updateInventory = true;
			}
		} else {
			progress = 0;
			updateState();
		}
		if (burning != isBurning()) {
			updateInventory = true;
		}
		if (updateInventory) {
			func_70296_d();
		}
	}

	public void cookItems() {
		if (this.canSmelt()) {
			ItemStack itemstack = FurnaceRecipes.func_77602_a().func_151395_a(func_70301_a(input1));

			if (func_70301_a(output) == null) {
				func_70299_a(output, itemstack.func_77946_l());
			} else if (func_70301_a(output).func_77969_a(itemstack)) {
				func_70301_a(output).field_77994_a += itemstack.field_77994_a;
			}
			if (func_70301_a(input1).field_77994_a > 1) {
				this.func_70298_a(input1, 1);
			} else {
				func_70299_a(input1, null);
			}
		}
	}

	public boolean canSmelt() {
		if (func_70301_a(input1) == null) {
			return false;
		} else {
			ItemStack itemstack = FurnaceRecipes.func_77602_a().func_151395_a(func_70301_a(input1));
			if (itemstack == null)
				return false;
			if (func_70301_a(output) == null)
				return true;
			if (!func_70301_a(output).func_77969_a(itemstack))
				return false;
			int result = func_70301_a(output).field_77994_a + itemstack.field_77994_a;
			return (result <= func_70297_j_() && result <= itemstack.func_77976_d());
		}
	}

	public boolean isBurning() {
		return getEnergy() > cost;
	}

	public ItemStack getResultFor(ItemStack stack) {
		ItemStack result = FurnaceRecipes.func_77602_a().func_151395_a(stack);
		if (result != null) {
			return result.func_77946_l();
		}
		return null;
	}

	public void updateState() {
		IBlockState BlockStateContainer = field_145850_b.func_180495_p(field_174879_c);
		if (BlockStateContainer.func_177230_c() instanceof BlockMachineBase) {
			BlockMachineBase blockMachineBase = (BlockMachineBase) BlockStateContainer.func_177230_c();
			if (BlockStateContainer.func_177229_b(BlockMachineBase.ACTIVE) != progress > 0)
				blockMachineBase.setActive(progress > 0, field_145850_b, field_174879_c);
		}
	}

	@Override
	public boolean wrenchCanSetFacing(EntityPlayer entityPlayer, EnumFacing side) {
		return false;
	}

	@Override
	public EnumFacing getFacing() {
		return getFacingEnum();
	}

	@Override
	public boolean wrenchCanRemove(EntityPlayer entityPlayer) {
		return entityPlayer.func_70093_af();
	}

	@Override
	public float getWrenchDropRate() {
		return 1.0F;
	}

	@Override
	public ItemStack getWrenchDrop(EntityPlayer entityPlayer) {
		return new ItemStack(ModBlocks.ElectricFurnace, 1);
	}

	public boolean isComplete() {
		return false;
	}

	// ISidedInventory
    @Override
    public int[] func_180463_a(EnumFacing side) {
        return new int[] {0, 1};
    }

    @Override
    public boolean func_180462_a(int index, ItemStack itemStackIn, EnumFacing direction) {
        return index == 0;
    }

    @Override
    public boolean func_180461_b(int index, ItemStack stack, EnumFacing direction) {
        return index == 1;
    }

	@Override
	public double getMaxPower() {
		return 16000;
	}

	@Override
	public EnumPowerTier getTier() {
		return EnumPowerTier.LOW;
	}

	@Override
	public Inventory getInventory() {
		return inventory;
	}
}
